package com.mvc.entity;

import java.util.ArrayList;
import java.util.List;

public class TProductionPlanDetailExample {
    /**
     * t_production_plan_detail
     */
    protected String orderByClause;

    /**
     * t_production_plan_detail
     */
    protected boolean distinct;

    /**
     * t_production_plan_detail
     */
    protected List<Criteria> oredCriteria;

    /**
     * @Description: 
     * @Author: guozhao
     * @CreateDate: 2024-11-12 18:28:45
     */
    public TProductionPlanDetailExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    /**
     * @Description: 
     * @Author: guozhao
     * @CreateDate: 2024-11-12 18:28:45
     */
    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    /**
     * @Description: 
     * @Author: guozhao
     * @CreateDate: 2024-11-12 18:28:45
     */
    public String getOrderByClause() {
        return orderByClause;
    }

    /**
     * @Description: 
     * @Author: guozhao
     * @CreateDate: 2024-11-12 18:28:45
     */
    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    /**
     * @Description: 
     * @Author: guozhao
     * @CreateDate: 2024-11-12 18:28:45
     */
    public boolean isDistinct() {
        return distinct;
    }

    /**
     * @Description: 
     * @Author: guozhao
     * @CreateDate: 2024-11-12 18:28:45
     */
    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    /**
     * @Description: 
     * @Author: guozhao
     * @CreateDate: 2024-11-12 18:28:45
     */
    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    /**
     * @Description: 
     * @Author: guozhao
     * @CreateDate: 2024-11-12 18:28:45
     */
    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    /**
     * @Description: 
     * @Author: guozhao
     * @CreateDate: 2024-11-12 18:28:45
     */
    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    /**
     * @Description: 
     * @Author: guozhao
     * @CreateDate: 2024-11-12 18:28:45
     */
    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    /**
     * @Description: 
     * @Author: guozhao
     * @CreateDate: 2024-11-12 18:28:45
     */
    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    /**
    * @Description:
    * @Author: guozhao
    * @CreateDate: 2024-11-12 18:28:45
    */
    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("ID is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("ID is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Integer value) {
            addCriterion("ID =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Integer value) {
            addCriterion("ID <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Integer value) {
            addCriterion("ID >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("ID >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Integer value) {
            addCriterion("ID <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Integer value) {
            addCriterion("ID <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Integer> values) {
            addCriterion("ID in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Integer> values) {
            addCriterion("ID not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Integer value1, Integer value2) {
            addCriterion("ID between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Integer value1, Integer value2) {
            addCriterion("ID not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andProductionPlanIdIsNull() {
            addCriterion("PRODUCTION_PLAN_ID is null");
            return (Criteria) this;
        }

        public Criteria andProductionPlanIdIsNotNull() {
            addCriterion("PRODUCTION_PLAN_ID is not null");
            return (Criteria) this;
        }

        public Criteria andProductionPlanIdEqualTo(Integer value) {
            addCriterion("PRODUCTION_PLAN_ID =", value, "productionPlanId");
            return (Criteria) this;
        }

        public Criteria andProductionPlanIdNotEqualTo(Integer value) {
            addCriterion("PRODUCTION_PLAN_ID <>", value, "productionPlanId");
            return (Criteria) this;
        }

        public Criteria andProductionPlanIdGreaterThan(Integer value) {
            addCriterion("PRODUCTION_PLAN_ID >", value, "productionPlanId");
            return (Criteria) this;
        }

        public Criteria andProductionPlanIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("PRODUCTION_PLAN_ID >=", value, "productionPlanId");
            return (Criteria) this;
        }

        public Criteria andProductionPlanIdLessThan(Integer value) {
            addCriterion("PRODUCTION_PLAN_ID <", value, "productionPlanId");
            return (Criteria) this;
        }

        public Criteria andProductionPlanIdLessThanOrEqualTo(Integer value) {
            addCriterion("PRODUCTION_PLAN_ID <=", value, "productionPlanId");
            return (Criteria) this;
        }

        public Criteria andProductionPlanIdIn(List<Integer> values) {
            addCriterion("PRODUCTION_PLAN_ID in", values, "productionPlanId");
            return (Criteria) this;
        }

        public Criteria andProductionPlanIdNotIn(List<Integer> values) {
            addCriterion("PRODUCTION_PLAN_ID not in", values, "productionPlanId");
            return (Criteria) this;
        }

        public Criteria andProductionPlanIdBetween(Integer value1, Integer value2) {
            addCriterion("PRODUCTION_PLAN_ID between", value1, value2, "productionPlanId");
            return (Criteria) this;
        }

        public Criteria andProductionPlanIdNotBetween(Integer value1, Integer value2) {
            addCriterion("PRODUCTION_PLAN_ID not between", value1, value2, "productionPlanId");
            return (Criteria) this;
        }

        public Criteria andDicPartIdIsNull() {
            addCriterion("DIC_PART_ID is null");
            return (Criteria) this;
        }

        public Criteria andDicPartIdIsNotNull() {
            addCriterion("DIC_PART_ID is not null");
            return (Criteria) this;
        }

        public Criteria andDicPartIdEqualTo(Integer value) {
            addCriterion("DIC_PART_ID =", value, "dicPartId");
            return (Criteria) this;
        }

        public Criteria andDicPartIdNotEqualTo(Integer value) {
            addCriterion("DIC_PART_ID <>", value, "dicPartId");
            return (Criteria) this;
        }

        public Criteria andDicPartIdGreaterThan(Integer value) {
            addCriterion("DIC_PART_ID >", value, "dicPartId");
            return (Criteria) this;
        }

        public Criteria andDicPartIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("DIC_PART_ID >=", value, "dicPartId");
            return (Criteria) this;
        }

        public Criteria andDicPartIdLessThan(Integer value) {
            addCriterion("DIC_PART_ID <", value, "dicPartId");
            return (Criteria) this;
        }

        public Criteria andDicPartIdLessThanOrEqualTo(Integer value) {
            addCriterion("DIC_PART_ID <=", value, "dicPartId");
            return (Criteria) this;
        }

        public Criteria andDicPartIdIn(List<Integer> values) {
            addCriterion("DIC_PART_ID in", values, "dicPartId");
            return (Criteria) this;
        }

        public Criteria andDicPartIdNotIn(List<Integer> values) {
            addCriterion("DIC_PART_ID not in", values, "dicPartId");
            return (Criteria) this;
        }

        public Criteria andDicPartIdBetween(Integer value1, Integer value2) {
            addCriterion("DIC_PART_ID between", value1, value2, "dicPartId");
            return (Criteria) this;
        }

        public Criteria andDicPartIdNotBetween(Integer value1, Integer value2) {
            addCriterion("DIC_PART_ID not between", value1, value2, "dicPartId");
            return (Criteria) this;
        }

        public Criteria andDicPartParentIdIsNull() {
            addCriterion("DIC_PART_PARENT_ID is null");
            return (Criteria) this;
        }

        public Criteria andDicPartParentIdIsNotNull() {
            addCriterion("DIC_PART_PARENT_ID is not null");
            return (Criteria) this;
        }

        public Criteria andDicPartParentIdEqualTo(Integer value) {
            addCriterion("DIC_PART_PARENT_ID =", value, "dicPartParentId");
            return (Criteria) this;
        }

        public Criteria andDicPartParentIdNotEqualTo(Integer value) {
            addCriterion("DIC_PART_PARENT_ID <>", value, "dicPartParentId");
            return (Criteria) this;
        }

        public Criteria andDicPartParentIdGreaterThan(Integer value) {
            addCriterion("DIC_PART_PARENT_ID >", value, "dicPartParentId");
            return (Criteria) this;
        }

        public Criteria andDicPartParentIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("DIC_PART_PARENT_ID >=", value, "dicPartParentId");
            return (Criteria) this;
        }

        public Criteria andDicPartParentIdLessThan(Integer value) {
            addCriterion("DIC_PART_PARENT_ID <", value, "dicPartParentId");
            return (Criteria) this;
        }

        public Criteria andDicPartParentIdLessThanOrEqualTo(Integer value) {
            addCriterion("DIC_PART_PARENT_ID <=", value, "dicPartParentId");
            return (Criteria) this;
        }

        public Criteria andDicPartParentIdIn(List<Integer> values) {
            addCriterion("DIC_PART_PARENT_ID in", values, "dicPartParentId");
            return (Criteria) this;
        }

        public Criteria andDicPartParentIdNotIn(List<Integer> values) {
            addCriterion("DIC_PART_PARENT_ID not in", values, "dicPartParentId");
            return (Criteria) this;
        }

        public Criteria andDicPartParentIdBetween(Integer value1, Integer value2) {
            addCriterion("DIC_PART_PARENT_ID between", value1, value2, "dicPartParentId");
            return (Criteria) this;
        }

        public Criteria andDicPartParentIdNotBetween(Integer value1, Integer value2) {
            addCriterion("DIC_PART_PARENT_ID not between", value1, value2, "dicPartParentId");
            return (Criteria) this;
        }
    }

    /**
    * @Description:
    * @Author: guozhao
    * @CreateDate: 2024-11-12 18:28:45
    */
    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    /**
    * @Description:
    * @Author: guozhao
    * @CreateDate: 2024-11-12 18:28:45
    */
    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}